AFPSBooster = {}

local dViewDist = nil
local dParticleDensity = nil

local f = CreateFrame("Frame")

local function IsInArdenweald () 
	if GetZoneText() == "Ardenweald" then
	return true else return false
end end

local function IsInOptionalZone () 
	if OptionalZonesBool then
		if (GetZoneText() == "Spires of Ascension" or 
		GetZoneText() == "Bastion Arena" or 
		GetSubZoneText() == "The Fracture Chambers")
		then
		return true else return false
	end
end end

local function ToggleSettings () 
	if IsInArdenweald() then
		SetCVar("graphicsParticleDensity", 2)
	elseif IsInOptionalZone() then
		if (GetZoneText() == "Spires of Ascension" or
		GetZoneText() == "Bastion Arena")
		then
			SetCVar("graphicsViewDistance", 3)
		end
		SetCVar("graphicsParticleDensity", 2)
	else
		SetCVar("graphicsViewDistance", dViewDist)
		SetCVar("graphicsParticleDensity", dParticleDensity)
	end	
end

f:RegisterEvent("PLAYER_LOGIN");
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:RegisterEvent("ZONE_CHANGED");
f:RegisterEvent("ZONE_CHANGED_INDOORS");
f:RegisterEvent("ZONE_CHANGED_NEW_AREA");
f:RegisterEvent("PLAYER_LOGOUT");
f:SetScript("OnEvent", function(self, event,...) f.OnEvent(self,event,...) end);

function f.OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		if dParticleDensity == nil then
			dParticleDensity = GetCVar("graphicsParticleDensity")
		end
		if dViewDist == nil then
			dViewDist = GetCVar("graphicsViewDistance")
		end
		print ("AFPS Booster ENABLED! Type '/afps config' for configuration.")
	end
	
	if (event == "PLAYER_ENTERING_WORLD" or event == "ZONE_CHANGED" or event == "ZONE_CHANGED_INDOORS" or event == "ZONE_CHANGED_NEW_AREA") then
		ToggleSettings()
		--print ("Entering Zone.")
	end
	
	if event == "PLAYER_LOGOUT" then
		SetCVar("graphicsViewDistance", dViewDist)
		SetCVar("graphicsParticleDensity", dParticleDensity)
	end
end

SLASH_AFPSBOOSTER1 = '/afps'
function SlashCmdList.AFPSBOOSTER(Msg, EditBox)
	local lMsg
	if Msg then lMsg = string.lower(Msg) end
	
	if Msg == 'full' then
		OptionalZonesBool = true
		ToggleSettings()
		print ("Optional Zones ENABLED.")
	elseif Msg == 'lite' then 
		OptionalZonesBool = false
		ToggleSettings()
		print ("Optional Zones DISABLED.")
	elseif Msg == 'config' then
		if OptionalZonesBool then
			print ("Please Type '/afps lite' to DISABLE the addon for all OPTIONAL zones.")
		else 
			print ("Please Type '/afps full' to ENABLE the addon for all OPTIONAL zones.")
		end
		print ("Supported Zones: Ardenweald (Default), Spires of Ascension (Optional), Bastion Arena (Optional), Fracture Chambers (Optional).")
	elseif Msg == 'debug' then
		print(GetZoneText(), " / ", GetSubZoneText())
	else 
		local pValue = GetCVar("graphicsParticleDensity")
		local vValue = GetCVar("graphicsViewDistance")
		if (IsInArdenweald() or IsInOptionalZone()) then
			print("AFPS Active In Zone. Settings OPTIMIZED (pDensity:", pValue, ")", "(vDistance:", vValue,").")
		else
			print("AFPS Inactive In Zone. Settings DEFAULT (pDensity:", pValue, ")", "(vDistance:", vValue,").")
		end
		print ("Type '/afps config' for configuration options.")
	end
end